package dev.shadowsoffire.apotheosis.util;

import net.minecraft.world.item.ArmorMaterials;
import net.minecraft.world.item.Tiers;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Ingredient;
import java.util.function.Supplier;
import java.util.Iterator;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import java.util.ArrayList;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.item.Item;
import java.util.List;
import java.util.HashMap;
import com.google.common.base.Preconditions;
import dev.shadowsoffire.placebo.config.Configuration;
import java.util.stream.Stream;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.item.ProjectileWeaponItem;
import net.minecraftforge.common.ToolActions;
import net.minecraft.world.item.SwordItem;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.function.Predicate;
import java.util.Set;
import java.util.Objects;
import net.minecraftforge.common.ToolAction;
import net.minecraft.world.item.TieredItem;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.Mob;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.Tier;
import java.util.Map;

public class NameHelper
{
    private static String[] names;
    private static String[] nameParts;
    private static String[] prefixes;
    private static String[] suffixes;
    private static String[] helms;
    private static String[] chestplates;
    private static String[] leggings;
    private static String[] boots;
    private static String[] swords;
    private static String[] axes;
    private static String[] pickaxes;
    private static String[] shovels;
    private static String[] bows;
    private static String[] shields;
    private static Map<Tier, String> tierKeys;
    private static Map<ArmorMaterial, String> materialKeys;
    private static Map<String, String[]> tierNames;
    private static Map<String, String[]> materialNames;
    public static String suffixFormat;
    public static String ownershipFormat;
    public static String chainFormat;
    
    public static String nameFromParts(final RandomSource random) {
        String name = NameHelper.nameParts[random.m_188503_(NameHelper.nameParts.length)] + NameHelper.nameParts[random.m_188503_(NameHelper.nameParts.length)].toLowerCase();
        if (random.m_188501_() < 0.4f) {
            name += NameHelper.nameParts[random.m_188503_(NameHelper.nameParts.length)].toLowerCase();
        }
        if (random.m_188501_() < 0.15f) {
            name += NameHelper.nameParts[random.m_188503_(NameHelper.nameParts.length)].toLowerCase();
        }
        return name;
    }
    
    public static String setEntityName(final RandomSource rand, final Mob entity) {
        String root;
        if (NameHelper.names.length > 0 && NameHelper.nameParts.length > 0) {
            root = ((rand.m_188501_() < 0.8f) ? NameHelper.names[rand.m_188503_(NameHelper.names.length)] : nameFromParts(rand));
        }
        else if (NameHelper.names.length > 0) {
            root = NameHelper.names[rand.m_188503_(NameHelper.names.length)];
        }
        else {
            root = nameFromParts(rand);
        }
        String name = root;
        if (rand.m_188501_() < 0.3f && NameHelper.prefixes.length > 0) {
            name = NameHelper.prefixes[rand.m_188503_(NameHelper.prefixes.length)] + " " + name;
        }
        if (rand.m_188501_() < 0.8f && NameHelper.suffixes.length > 0) {
            name = String.format(NameHelper.suffixFormat, name, NameHelper.suffixes[rand.m_188503_(NameHelper.suffixes.length)]);
        }
        entity.m_6593_((Component)Component.m_237113_(name));
        entity.m_20340_(true);
        return root;
    }
    
    public static Component setItemName(final RandomSource random, final ItemStack stack) {
        MutableComponent name = (MutableComponent)stack.m_41720_().m_7626_(stack);
        final String baseName = name.getString();
        if (stack.m_41720_() instanceof final TieredItem tieredItem) {
            final Tier tier = tieredItem.m_43314_();
            final String[] tierNames = getTierNames(tier);
            if (tierNames.length == 0) {
                final String[] split = baseName.split(" ");
                String rebuilt = "";
                for (int i = 0; i < split.length - 1; ++i) {
                    rebuilt += split[i];
                }
                name = Component.m_237113_(rebuilt);
            }
            else {
                name = Component.m_237113_(tierNames[random.m_188503_(tierNames.length)]);
            }
            String[] type = { "Tool" };
            final Stream stream = ToolAction.getActions().stream();
            Objects.requireNonNull(stack);
            final Set<ToolAction> types = (Set<ToolAction>)stream.filter(stack::canPerformAction).collect(Collectors.toSet());
            if (stack.m_41720_() instanceof SwordItem) {
                type = NameHelper.swords;
            }
            else if (types.contains(ToolActions.AXE_DIG)) {
                type = NameHelper.axes;
            }
            else if (types.contains(ToolActions.PICKAXE_DIG)) {
                type = NameHelper.pickaxes;
            }
            else if (types.contains(ToolActions.SHOVEL_DIG)) {
                type = NameHelper.shovels;
            }
            else if (types.contains(ToolActions.SHIELD_BLOCK)) {
                type = NameHelper.shields;
            }
            name.m_130946_(type[random.m_188503_(type.length)]);
        }
        else if (stack.m_41720_() instanceof ProjectileWeaponItem) {
            final String[] type2 = NameHelper.bows;
            name = Component.m_237113_(type2[random.m_188503_(type2.length)]);
        }
        else if (stack.m_41720_() instanceof final ArmorItem armorItem) {
            final ArmorMaterial armorMat = armorItem.m_40401_();
            final String[] matNames = getMaterialNames(armorMat);
            if (matNames.length == 0) {
                final String[] split = baseName.split(" ");
                String rebuilt = "";
                for (int i = 0; i < split.length - 1; ++i) {
                    rebuilt += split[i];
                }
                name = Component.m_237113_(rebuilt);
            }
            else {
                name = Component.m_237113_(matNames[random.m_188503_(matNames.length)]);
            }
            String[] type = { "Armor" };
            switch (((ArmorItem)stack.m_41720_()).m_40402_()) {
                case HEAD: {
                    type = NameHelper.helms;
                    break;
                }
                case CHEST: {
                    type = NameHelper.chestplates;
                    break;
                }
                case LEGS: {
                    type = NameHelper.leggings;
                    break;
                }
                case FEET: {
                    type = NameHelper.boots;
                    break;
                }
            }
            name.m_130946_(type[random.m_188503_(type.length)]);
        }
        stack.m_41714_((Component)name);
        return (Component)name;
    }
    
    public static String[] getTierNames(final Tier materialName) {
        return NameHelper.tierNames.computeIfAbsent(getKey(materialName), s -> new String[0]);
    }
    
    public static String[] getMaterialNames(final ArmorMaterial materialName) {
        return NameHelper.materialNames.computeIfAbsent(getKey(materialName), s -> new String[0]);
    }
    
    public static void load(final Configuration c) {
        NameHelper.names = c.getStringList("Names", "entity", NameHelper.names, "A list of full names, which are used in the generation of boss names. May be empty only if name parts is not empty.");
        NameHelper.nameParts = c.getStringList("Name Parts", "entity", NameHelper.nameParts, "A list of name pieces, which can be spliced together to create full names.  May be empty only if names is not empty.");
        Preconditions.checkArgument(NameHelper.names.length != 0 || NameHelper.nameParts.length != 0, (Object)"Both names and name parts are empty in apotheosis/names.cfg, this is not allowed.");
        NameHelper.prefixes = c.getStringList("Prefixes", "entity", NameHelper.prefixes, "A list of prefixes, which are used in the generation of boss names. May be empty.");
        NameHelper.suffixes = c.getStringList("Suffixes", "entity", NameHelper.suffixes, "A list of suffixes, which are used in the generation of boss names. A suffix is always preceeded by \"The\". May be empty.");
        NameHelper.helms = c.getStringList("Helms", "items", NameHelper.helms, "A list of root names for helms, used in the generation of item names. May not be empty.");
        NameHelper.chestplates = c.getStringList("chestplates", "items", NameHelper.chestplates, "A list of root names for chestplates, used in the generation of item names. May not be empty.");
        NameHelper.leggings = c.getStringList("leggings", "items", NameHelper.leggings, "A list of root names for leggings, used in the generation of item names. May not be empty.");
        NameHelper.boots = c.getStringList("boots", "items", NameHelper.boots, "A list of root names for boots, used in the generation of item names. May not be empty.");
        Preconditions.checkArgument(NameHelper.helms.length > 0 && NameHelper.chestplates.length > 0 && NameHelper.leggings.length > 0 && NameHelper.boots.length > 0, (Object)"Detected empty lists for armor root names in apotheosis/names.cfg, this is not allowed.");
        NameHelper.swords = c.getStringList("swords", "items", NameHelper.swords, "A list of root names for swords, used in the generation of item names. May not be empty.");
        NameHelper.axes = c.getStringList("axes", "items", NameHelper.axes, "A list of root names for axes, used in the generation of item names. May not be empty.");
        NameHelper.pickaxes = c.getStringList("pickaxes", "items", NameHelper.pickaxes, "A list of root names for pickaxes, used in the generation of item names. May not be empty.");
        NameHelper.shovels = c.getStringList("shovels", "items", NameHelper.shovels, "A list of root names for shovels, used in the generation of item names. May not be empty.");
        NameHelper.bows = c.getStringList("bows", "items", NameHelper.bows, "A list of root names for bows, used in the generation of item names. May not be empty.");
        NameHelper.shields = c.getStringList("shields", "items", NameHelper.shields, "A list of root names for shields, used in the generation of item names. May not be empty.");
        Preconditions.checkArgument(NameHelper.swords.length > 0 && NameHelper.axes.length > 0 && NameHelper.pickaxes.length > 0 && NameHelper.shovels.length > 0 && NameHelper.bows.length > 0, (Object)"Detected empty lists for weapon root names in apotheosis/names.cfg, this is not allowed.");
        final Map<Tier, List<Item>> itemsByTier = new HashMap<Tier, List<Item>>();
        final Map<ArmorMaterial, List<Item>> armorsByTier = new HashMap<ArmorMaterial, List<Item>>();
        for (final Item i : ForgeRegistries.ITEMS) {
            try {
                if (i instanceof final TieredItem tieredItem) {
                    final Tier mat = tieredItem.m_43314_();
                    itemsByTier.computeIfAbsent(mat, m -> new ArrayList()).add(i);
                }
                if (!(i instanceof ArmorItem)) {
                    continue;
                }
                final ArmorMaterial mat2 = ((ArmorItem)i).m_40401_();
                armorsByTier.computeIfAbsent(mat2, m -> new ArrayList()).add(i);
            }
            catch (final Exception e) {
                AdventureModule.LOGGER.error("The item {} has thrown an exception while attempting to access it's tier.", (Object)ForgeRegistries.ITEMS.getKey((Object)i));
                e.printStackTrace();
            }
        }
        for (final Map.Entry<Tier, List<Item>> e2 : itemsByTier.entrySet()) {
            final Tier tier = e2.getKey();
            final List<Item> items = e2.getValue();
            final String key = getID(tier, items);
            NameHelper.tierKeys.put(tier, key);
            final String s = key;
            final String s2 = "tools";
            final String[] array = NameHelper.tierNames.getOrDefault(tier, new String[0]);
            final List<Item> items2 = items;
            final Tier obj = tier;
            Objects.requireNonNull(obj);
            final String[] read = c.getStringList(s, s2, array, computeComment(items2, obj::m_6282_));
            if (read.length > 0) {
                NameHelper.tierNames.put(key, read);
            }
        }
        for (final Map.Entry<ArmorMaterial, List<Item>> e3 : armorsByTier.entrySet()) {
            final ArmorMaterial tier2 = e3.getKey();
            final List<Item> items = e3.getValue();
            final String id;
            final String key = id = getID(tier2, items);
            final String s3 = "armors";
            final String[] array2 = NameHelper.materialNames.getOrDefault(tier2, new String[0]);
            final List<Item> items3 = items;
            final ArmorMaterial obj2 = tier2;
            Objects.requireNonNull(obj2);
            final String[] read = c.getStringList(id, s3, array2, computeComment(items3, obj2::m_6230_));
            if (read.length > 0) {
                NameHelper.materialNames.put(key, read);
            }
        }
        NameHelper.suffixFormat = c.getString("Suffix Format", "formatting", NameHelper.suffixFormat, "The format string that will be used when a suffix is applied.");
        NameHelper.ownershipFormat = c.getString("Ownership Format", "formatting", NameHelper.ownershipFormat, "The format string that will be used to indicate ownership.");
        if (c.hasChanged()) {
            c.save();
        }
    }
    
    private static String computeComment(final List<Item> items, final Supplier<Ingredient> repair) {
        String cmt = "A list of material-based prefix names for this material group. May be empty.\n";
        cmt += "Items in this group: ";
        for (Item i : items) {
            cmt = cmt + ForgeRegistries.ITEMS.getKey((Object)i) + ", ";
        }
        cmt = cmt.substring(0, cmt.length() - 2);
        return cmt;
    }
    
    private static String getID(final Object o, final List<Item> items) {
        if (o instanceof final Enum enum1) {
            return enum1.name();
        }
        final ResourceLocation id = ForgeRegistries.ITEMS.getKey((Object)items.get(0));
        return id.m_135827_() + "_" + id.m_135815_();
    }
    
    private static String getKey(final Tier tier) {
        return NameHelper.tierKeys.getOrDefault(tier, "");
    }
    
    private static String getKey(final ArmorMaterial mat) {
        return NameHelper.materialKeys.getOrDefault(mat, "");
    }
    
    static {
        NameHelper.names = new String[] { "Prim", "Tyrael", "Bajorno", "Michael Morbius", "Morbius", "Arun", "Panez", "Doomsday", "Vanamar", "WhatTheDrunk", "Lothrazar", "Chelly", "Chelicia", "Darsh", "Dariush", "Cheese E Piloza", "Bing", "Royal", "NoWayHere", "SwankyStella", "Isosahedron", "Asfalis", "Biz", "Icicle", "Darko", "Shadows", "Katarina", "Faellynna", "Diliviel", "Jank", "Albert", "Andrew", "Anderson", "Andy", "Allan", "Arthur", "Aaron", "Allison", "Arielle", "Amanda", "Anne", "Annie", "Amy", "Alana", "Brandon", "Brady", "Bernard", "Ben", "Benjamin", "Bob", "Bobette", "Brooke", "Brandy", "Beatrice", "Bea", "Bella", "Becky", "Carlton", "Carl", "Calvin", "Cameron", "Carson", "Chase", "Cassandra", "Cassie", "Cas", "Carol", "Carly", "Cherise", "Charlotte", "Cheryl", "Chasity", "Danny", "Drake", "Daniel", "Derrel", "David", "Dave", "Donovan", "Don", "Donald", "Drew", "Derrick", "Darla", "Donna", "Dora", "Danielle", "Edward", "Elliot", "Ed", "Edson", "Elton", "Eddison", "Earl", "Eric", "Ericson", "Eddie", "Ediovany", "Emma", "Elizabeth", "Eliza", "Esperanza", "Esper", "Esmeralda", "Emi", "Emily", "Elaine", "Fernando", "Ferdinand", "Fred", "Feddie", "Fredward", "Frank", "Franklin", "Felix", "Felicia", "Fran", "Greg", "Gregory", "George", "Gerald", "Gina", "Geraldine", "Gabby", "Hendrix", "Henry", "Hobbes", "Herbert", "Heath", "Henderson", "Helga", "Hera", "Helen", "Helena", "Hannah", "Ike", "Issac", "Israel", "Ismael", "Irlanda", "Isabelle", "Irene", "Irenia", "Jimmy", "Jim", "Justin", "Jacob", "Jake", "Jon", "Johnson", "Jonny", "Jonathan", "Josh", "Joshua", "Julian", "Jesus", "Jericho", "Jeb", "Jess", "Joan", "Jill", "Jillian", "Jessica", "Jennifer", "Jenny", "Jen", "Judy", "Kenneth", "Kenny", "Ken", "Keith", "Kevin", "Karen", "Kassandra", "Kassie", "Leonard", "Leo", "Leroy", "Lee", "Lenny", "Luke", "Lucas", "Liam", "Lorraine", "Latasha", "Lauren", "Laquisha", "Livia", "Lydia", "Lila", "Lilly", "Lillian", "Lilith", "Lana", "Mason", "Mike", "Mickey", "Mario", "Manny", "Mark", "Marcus", "Martin", "Marty", "Matthew", "Matt", "Max", "Maximillian", "Marth", "Mia", "Marriah", "Maddison", "Maddie", "Marissa", "Miranda", "Mary", "Martha", "Melonie", "Melody", "Mel", "Minnie", "Nathan", "Nathaniel", "Nate", "Ned", "Nick", "Norman", "Nicholas", "Natasha", "Nicki", "Nora", "Nelly", "Nina", "Orville", "Oliver", "Orlando", "Owen", "Olsen", "Odin", "Olaf", "Ortega", "Olivia", "Patrick", "Pat", "Paul", "Perry", "Pinnochio", "Patrice", "Patricia", "Pennie", "Petunia", "Patti", "Pernelle", "Quade", "Quincy", "Quentin", "Quinn", "Roberto", "Robbie", "Rob", "Robert", "Roy", "Roland", "Ronald", "Richard", "Rick", "Ricky", "Rose", "Rosa", "Rhonda", "Rebecca", "Roberta", "Sparky", "Shiloh", "Stephen", "Steve", "Saul", "Sheen", "Shane", "Sean", "Sampson", "Samuel", "Sammy", "Stefan", "Sasha", "Sam", "Susan", "Suzy", "Shelby", "Samantha", "Sheila", "Sharon", "Sally", "Stephanie", "Sandra", "Sandy", "Sage", "Tim", "Thomas", "Thompson", "Tyson", "Tyler", "Tom", "Tyrone", "Timmothy", "Tamara", "Tabby", "Tabitha", "Tessa", "Tiara", "Tyra", "Uriel", "Ursala", "Uma", "Victor", "Vincent", "Vince", "Vance", "Vinny", "Velma", "Victoria", "Veronica", "Wilson", "Wally", "Wallace", "Will", "Wilard", "William", "Wilhelm", "Xavier", "Xandra", "Young", "Yvonne", "Yolanda", "Zach", "Zachary" };
        NameHelper.nameParts = new String[] { "Prim", "Morb", "Ius", "Kat", "Chel", "Bing", "Darsh", "Jank", "Dark", "Osto", "Grab", "Thar", "Ger", "Ald", "Mas", "On", "O", "Din", "Thor", "Jon", "Ath", "Burb", "En", "A", "E", "I", "U", "Hab", "Bloo", "Ena", "Dit", "Aph", "Ern", "Bor", "Dav", "Id", "Toast", "Son", "For", "Wen", "Lob", "Van", "Zap", "Ear", "Ben", "Don", "Bran", "Gro", "Jen", "Bob", "Ette", "Ere", "Man", "Qua", "Bro", "Cree", "Per", "Skel", "Ton", "Zom", "Bie", "Wolf", "End", "Er", "Pig", "Sil", "Ver", "Fish", "Cow", "Chic", "Ken", "Sheep", "Squid", "Hell" };
        NameHelper.prefixes = new String[] { "Dr. Michael", "Sir", "Mister", "Madam", "Doctor", "Father", "Mother", "Poppa", "Lord", "Lady", "Overseer", "Professor", "Mr.", "Mr. President", "Duke", "Duchess", "Dame", "The Honorable", "Chancellor", "Vice-Chancellor", "His Holiness", "Reverend", "Count", "Viscount", "Earl", "Captain", "Major", "General", "Senpai" };
        NameHelper.suffixes = new String[] { "Morbius", "Dragonborn", "Rejected", "Mighty", "Supreme", "Superior", "Ultimate", "Lame", "Wimpy", "Curious", "Sneaky", "Pathetic", "Crying", "Eagle", "Errant", "Unholy", "Questionable", "Mean", "Hungry", "Thirsty", "Feeble", "Wise", "Sage", "Magical", "Mythical", "Legendary", "Not Very Nice", "Jerk", "Doctor", "Misunderstood", "Angry", "Knight", "Bishop", "Godly", "Special", "Toasty", "Shiny", "Shimmering", "Light", "Dark", "Odd-Smelling", "Funky", "Rock Smasher", "Son of Herobrine", "Cracked", "Sticky", "§kAlien§r", "Baby", "Manly", "Rough", "Scary", "Undoubtable", "Honest", "Non-Suspicious", "Boring", "Odd", "Lazy", "Super", "Nifty", "Ogre Slayer", "Pig Thief", "Dirt Digger", "Really Cool", "Doominator", "... Something", "Extra-Fishy", "Gorilla Slaughterer", "Marbles Winner", "AC Rizzlord", "President", "Burger Chef", "Professional Animator", "Cheese Sprayer", "Happiness Advocate", "Ghost Hunter", "Head of Potatoes", "Ninja", "Warrior", "Pyromancer" };
        NameHelper.helms = new String[] { "Helmet", "Cap", "Crown", "Great Helm", "Bassinet", "Sallet", "Close Helm", "Barbute" };
        NameHelper.chestplates = new String[] { "Chestplate", "Tunic", "Brigandine", "Hauberk", "Cuirass" };
        NameHelper.leggings = new String[] { "Leggings", "Pants", "Tassets", "Cuisses", "Schynbalds" };
        NameHelper.boots = new String[] { "Boots", "Shoes", "Greaves", "Sabatons", "Sollerets" };
        NameHelper.swords = new String[] { "Sword", "Cutter", "Slicer", "Dicer", "Knife", "Blade", "Machete", "Brand", "Claymore", "Cutlass", "Foil", "Dagger", "Glaive", "Rapier", "Saber", "Scimitar", "Shortsword", "Longsword", "Broadsword", "Calibur" };
        NameHelper.axes = new String[] { "Axe", "Chopper", "Hatchet", "Tomahawk", "Cleaver", "Hacker", "Tree-Cutter", "Truncator" };
        NameHelper.pickaxes = new String[] { "Pickaxe", "Pick", "Mattock", "Rock-Smasher", "Miner" };
        NameHelper.shovels = new String[] { "Shovel", "Spade", "Digger", "Excavator", "Trowel", "Scoop" };
        NameHelper.bows = new String[] { "Bow", "Shortbow", "Longbow", "Flatbow", "Recurve Bow", "Reflex Bow", "Self Bow", "Composite Bow", "Arrow-Flinger" };
        NameHelper.shields = new String[] { "Shield", "Buckler", "Targe", "Greatshield", "Blockade", "Bulwark", "Tower Shield", "Protector", "Aegis" };
        NameHelper.tierKeys = new HashMap<Tier, String>();
        NameHelper.materialKeys = new HashMap<ArmorMaterial, String>();
        (NameHelper.tierNames = new HashMap<String, String[]>()).put(Tiers.WOOD.name(), new String[] { "Wooden", "Wood", "Hardwood", "Balsa Wood", "Mahogany", "Plywood" });
        NameHelper.tierNames.put(Tiers.STONE.name(), new String[] { "Stone", "Rock", "Marble", "Cobblestone" });
        NameHelper.tierNames.put(Tiers.IRON.name(), new String[] { "Iron", "Steel", "Ferrous", "Rusty", "Wrought Iron" });
        NameHelper.tierNames.put(Tiers.GOLD.name(), new String[] { "Golden", "Gold", "Gilt", "Auric", "Ornate" });
        NameHelper.tierNames.put(Tiers.DIAMOND.name(), new String[] { "Diamond", "Zircon", "Gemstone", "Jewel", "Crystal" });
        NameHelper.tierNames.put(Tiers.NETHERITE.name(), new String[] { "Burnt", "Embered", "Fiery", "Hellborn", "Flameforged" });
        NameHelper.tierNames.put("twilightforest_ironwood_sword", new String[] { "Ironwood", "Earthbound", "Oaken", "Ironcapped" });
        NameHelper.tierNames.put("twilightforest_knightmetal_sword", new String[] { "Knightmetal", "Knightly", "Phantom-Forged" });
        NameHelper.tierNames.put("twilightforest_steeleaf_sword", new String[] { "Steeleaf", "Organic", "Natural", "Cobaltstem", "Tungstenpetal" });
        NameHelper.tierNames.put("twilightforest_fiery_sword", new String[] { "Fiery", "Flaming", "Hydra-Infused", "Infernal" });
        (NameHelper.materialNames = new HashMap<String, String[]>()).put(ArmorMaterials.LEATHER.name(), new String[] { "Leather", "Rawhide", "Lamellar", "Cow Skin" });
        NameHelper.materialNames.put(ArmorMaterials.CHAIN.name(), new String[] { "Chainmail", "Chain", "Chain Link", "Scale" });
        NameHelper.materialNames.put(ArmorMaterials.IRON.name(), NameHelper.tierNames.get(Tiers.IRON.name()));
        NameHelper.materialNames.put(ArmorMaterials.GOLD.name(), NameHelper.tierNames.get(Tiers.GOLD.name()));
        NameHelper.materialNames.put(ArmorMaterials.DIAMOND.name(), NameHelper.tierNames.get(Tiers.DIAMOND.name()));
        NameHelper.materialNames.put(ArmorMaterials.NETHERITE.name(), NameHelper.tierNames.get(Tiers.NETHERITE.name()));
        NameHelper.materialNames.put(ArmorMaterials.TURTLE.name(), new String[] { "Tortollan", "Very Tragic", "Environmental", "Organic" });
        NameHelper.materialNames.put("ARMOR_IRONWOOD", NameHelper.tierNames.get("twilightforest_ironwood_sword"));
        NameHelper.materialNames.put("ARMOR_KNIGHTLY", NameHelper.tierNames.get("twilightforest_knightmetal_sword"));
        NameHelper.materialNames.put("ARMOR_STEELEAF", NameHelper.tierNames.get("twilightforest_steeleaf_sword"));
        NameHelper.materialNames.put("ARMOR_FIERY", NameHelper.tierNames.get("twilightforest_fiery_sword"));
        NameHelper.materialNames.put("ARMOR_ARCTIC", new String[] { "Arctic", "Frostforged", "Caribou Skin", "Gutskin", "Insulating" });
        NameHelper.materialNames.put("ARMOR_YETI", new String[] { "Yeti", "Abominable", "Snow-Demon", "Grinch" });
        NameHelper.suffixFormat = "%s the %s";
        NameHelper.ownershipFormat = "%s's";
        NameHelper.chainFormat = "%s %s";
    }
}
